|
|||||||||
| Home >> All >> org >> apache >> commons >> [ beanutils overview ] | PREV CLASS NEXT CLASS | ||||||||
SUMMARY: JAVADOC | SOURCE | DOWNLOAD | NESTED | FIELD | CONSTR | METHOD |
DETAIL: FIELD | CONSTR | METHOD | ||||||||
org.apache.commons.beanutils
Class BeanUtilsBean

java.lang.Objectorg.apache.commons.beanutils.BeanUtilsBean
- public class BeanUtilsBean
- extends java.lang.Object
JavaBean property population methods.
This class provides implementations for the utility methods in BeanUtils. Different instances can be used to isolate caches between classloaders and to vary the value converters registered.
- Since:
- 1.7
- Version:
- $Revision: 1.16 $ $Date: 2004/02/28 13:18:33 $
| Field Summary | |
private static ContextClassLoaderLocal |
beansByClassLoader
Contains BeanUtilsBean instances indexed by context classloader. |
private ConvertUtilsBean |
convertUtilsBean
Used to perform conversions between object types when setting properties |
private org.apache.commons.logging.Log |
log
Logging for this instance |
private PropertyUtilsBean |
propertyUtilsBean
Used to access properties |
| Constructor Summary | |
BeanUtilsBean()
Constructs an instance using new property and conversion instances. |
|
BeanUtilsBean(ConvertUtilsBean convertUtilsBean,
PropertyUtilsBean propertyUtilsBean)
Constructs an instance using given property and conversion instances. |
|
| Method Summary | |
java.lang.Object |
cloneBean(java.lang.Object bean)
Clone a bean based on the available property getters and setters, even if the bean class itself does not implement Cloneable. |
void |
copyProperties(java.lang.Object dest,
java.lang.Object orig)
Copy property values from the origin bean to the destination bean for all cases where the property names are the same. |
void |
copyProperty(java.lang.Object bean,
java.lang.String name,
java.lang.Object value)
Copy the specified property value to the specified destination bean, performing any type conversion that is required. |
java.util.Map |
describe(java.lang.Object bean)
Return the entire set of properties for which the specified bean provides a read method. |
private int |
findLastNestedIndex(java.lang.String expression)
|
java.lang.String[] |
getArrayProperty(java.lang.Object bean,
java.lang.String name)
Return the value of the specified array property of the specified bean, as a String array. |
ConvertUtilsBean |
getConvertUtils()
Gets the ConvertUtilsBean instance used to perform the conversions. |
java.lang.String |
getIndexedProperty(java.lang.Object bean,
java.lang.String name)
Return the value of the specified indexed property of the specified bean, as a String. |
java.lang.String |
getIndexedProperty(java.lang.Object bean,
java.lang.String name,
int index)
Return the value of the specified indexed property of the specified bean, as a String. |
static BeanUtilsBean |
getInstance()
Gets the instance which provides the functionality for BeanUtils. |
java.lang.String |
getMappedProperty(java.lang.Object bean,
java.lang.String name)
Return the value of the specified indexed property of the specified bean, as a String. |
java.lang.String |
getMappedProperty(java.lang.Object bean,
java.lang.String name,
java.lang.String key)
Return the value of the specified mapped property of the specified bean, as a String. |
java.lang.String |
getNestedProperty(java.lang.Object bean,
java.lang.String name)
Return the value of the (possibly nested) property of the specified name, for the specified bean, as a String. |
java.lang.String |
getProperty(java.lang.Object bean,
java.lang.String name)
Return the value of the specified property of the specified bean, no matter which property reference format is used, as a String. |
PropertyUtilsBean |
getPropertyUtils()
Gets the PropertyUtilsBean instance used to access properties. |
java.lang.String |
getSimpleProperty(java.lang.Object bean,
java.lang.String name)
Return the value of the specified simple property of the specified bean, converted to a String. |
void |
populate(java.lang.Object bean,
java.util.Map properties)
Populate the JavaBeans properties of the specified bean, based on the specified name/value pairs. |
static void |
setInstance(BeanUtilsBean newInstance)
Sets the instance which provides the functionality for BeanUtils. |
void |
setProperty(java.lang.Object bean,
java.lang.String name,
java.lang.Object value)
Set the specified property value, performing type conversions as required to conform to the type of the destination property. |
| Methods inherited from class java.lang.Object |
clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait |
| Field Detail |
beansByClassLoader
private static final ContextClassLoaderLocal beansByClassLoader
- Contains
BeanUtilsBeaninstances indexed by context classloader.
log
private org.apache.commons.logging.Log log
- Logging for this instance
convertUtilsBean
private ConvertUtilsBean convertUtilsBean
- Used to perform conversions between object types when setting properties
propertyUtilsBean
private PropertyUtilsBean propertyUtilsBean
- Used to access properties
| Constructor Detail |
BeanUtilsBean
public BeanUtilsBean()
Constructs an instance using new property and conversion instances.
BeanUtilsBean
public BeanUtilsBean(ConvertUtilsBean convertUtilsBean, PropertyUtilsBean propertyUtilsBean)
Constructs an instance using given property and conversion instances.
| Method Detail |
getInstance
public static BeanUtilsBean getInstance()
- Gets the instance which provides the functionality for BeanUtils.
This is a pseudo-singleton - an single instance is provided per (thread) context classloader.
This mechanism provides isolation for web apps deployed in the same container.
setInstance
public static void setInstance(BeanUtilsBean newInstance)
- Sets the instance which provides the functionality for BeanUtils.
This is a pseudo-singleton - an single instance is provided per (thread) context classloader.
This mechanism provides isolation for web apps deployed in the same container.
cloneBean
public java.lang.Object cloneBean(java.lang.Object bean) throws java.lang.IllegalAccessException, java.lang.InstantiationException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
Clone a bean based on the available property getters and setters, even if the bean class itself does not implement Cloneable.
Note: this method creates a shallow clone. In other words, any objects referred to by the bean are shared with the clone rather than being cloned in turn.
copyProperties
public void copyProperties(java.lang.Object dest, java.lang.Object orig) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException
Copy property values from the origin bean to the destination bean for all cases where the property names are the same. For each property, a conversion is attempted as necessary. All combinations of standard JavaBeans and DynaBeans as origin and destination are supported. Properties that exist in the origin bean, but do not exist in the destination bean (or are read-only in the destination bean) are silently ignored.
If the origin "bean" is actually a
Map, it is assumed to contain String-valued simple property names as the keys, pointing at the corresponding property values that will be converted (if necessary) and set in the destination bean. Note that this method is intended to perform a "shallow copy" of the properties and so complex properties (for example, nested ones) will not be copied.This method differs from
populate(), which was primarily designed for populating JavaBeans from the map of request parameters retrieved on an HTTP request, is that no scalar->indexed or indexed->scalar manipulations are performed. If the origin property is indexed, the destination property must be also.If you know that no type conversions are required, the
copyProperties()method in PropertyUtils will execute faster than this method.FIXME - Indexed and mapped properties that do not have getter and setter methods for the underlying array or Map are not copied by this method.
copyProperty
public void copyProperty(java.lang.Object bean, java.lang.String name, java.lang.Object value) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException
Copy the specified property value to the specified destination bean, performing any type conversion that is required. If the specified bean does not have a property of the specified name, or the property is read only on the destination bean, return without doing anything. If you have custom destination property types, register Converters for them by calling the
register()method of ConvertUtils.IMPLEMENTATION RESTRICTIONS:
- Does not support destination properties that are indexed, but only an indexed setter (as opposed to an array setter) is available.
- Does not support destination properties that are mapped, but only a keyed setter (as opposed to a Map setter) is available.
- The desired property type of a mapped setter cannot be determined (since Maps support any data type), so no conversion will be performed.
describe
public java.util.Map describe(java.lang.Object bean) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
Return the entire set of properties for which the specified bean provides a read method. This map contains the to
Stringconverted property values for all properties for which a read method is provided (i.e. where the getReadMethod() returns non-null).This map can be fed back to a call to
BeanUtils.populate()to reconsitute the same set of properties, modulo differences for read-only and write-only properties, but only if there are no indexed properties.
getArrayProperty
public java.lang.String[] getArrayProperty(java.lang.Object bean, java.lang.String name) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified array property of the specified
bean, as a String array.
getIndexedProperty
public java.lang.String getIndexedProperty(java.lang.Object bean, java.lang.String name) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified indexed property of the specified
bean, as a String. The zero-relative index of the
required value must be included (in square brackets) as a suffix to
the property name, or
IllegalArgumentExceptionwill be thrown.
getIndexedProperty
public java.lang.String getIndexedProperty(java.lang.Object bean, java.lang.String name, int index) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified indexed property of the specified
bean, as a String. The index is specified as a method parameter and
must *not* be included in the property name expression
getMappedProperty
public java.lang.String getMappedProperty(java.lang.Object bean, java.lang.String name) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified indexed property of the specified
bean, as a String. The String-valued key of the required value
must be included (in parentheses) as a suffix to
the property name, or
IllegalArgumentExceptionwill be thrown.
getMappedProperty
public java.lang.String getMappedProperty(java.lang.Object bean, java.lang.String name, java.lang.String key) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified mapped property of the specified
bean, as a String. The key is specified as a method parameter and
must *not* be included in the property name expression
getNestedProperty
public java.lang.String getNestedProperty(java.lang.Object bean, java.lang.String name) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the (possibly nested) property of the specified
name, for the specified bean, as a String.
getProperty
public java.lang.String getProperty(java.lang.Object bean, java.lang.String name) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified property of the specified bean,
no matter which property reference format is used, as a String.
getSimpleProperty
public java.lang.String getSimpleProperty(java.lang.Object bean, java.lang.String name) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException, java.lang.NoSuchMethodException
- Return the value of the specified simple property of the specified
bean, converted to a String.
populate
public void populate(java.lang.Object bean, java.util.Map properties) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException
Populate the JavaBeans properties of the specified bean, based on the specified name/value pairs. This method uses Java reflection APIs to identify corresponding "property setter" method names, and deals with setter arguments of type
String,boolean,int,long,float, anddouble. In addition, array setters for these types (or the corresponding primitive types) can also be identified.The particular setter method to be called for each property is determined using the usual JavaBeans introspection mechanisms. Thus, you may identify custom setter methods using a BeanInfo class that is associated with the class of the bean itself. If no such BeanInfo class is available, the standard method name conversion ("set" plus the capitalized name of the property in question) is used.
NOTE: It is contrary to the JavaBeans Specification to have more than one setter method (with different argument signatures) for the same property.
WARNING - The logic of this method is customized for extracting String-based request parameters from an HTTP request. It is probably not what you want for general property copying with type conversion. For that purpose, check out the
copyProperties()method instead.
setProperty
public void setProperty(java.lang.Object bean, java.lang.String name, java.lang.Object value) throws java.lang.IllegalAccessException, java.lang.reflect.InvocationTargetException
Set the specified property value, performing type conversions as required to conform to the type of the destination property.
If the property is read only then the method returns without throwing an exception.
If
nullis passed into a property expecting a primitive value, then this will be converted as if it were anullstring.WARNING - The logic of this method is customized to meet the needs of
populate(), and is probably not what you want for general property copying with type conversion. For that purpose, check out thecopyProperty()method instead.WARNING - PLEASE do not modify the behavior of this method without consulting with the Struts developer community. There are some subtleties to its functionality that are not documented in the Javadoc description above, yet are vital to the way that Struts utilizes this method.
findLastNestedIndex
private int findLastNestedIndex(java.lang.String expression)
getConvertUtils
public ConvertUtilsBean getConvertUtils()
- Gets the
ConvertUtilsBeaninstance used to perform the conversions.
getPropertyUtils
public PropertyUtilsBean getPropertyUtils()
- Gets the
PropertyUtilsBeaninstance used to access properties.
|
|||||||||
| Home >> All >> org >> apache >> commons >> [ beanutils overview ] | PREV CLASS NEXT CLASS | ||||||||
SUMMARY: JAVADOC | SOURCE | DOWNLOAD | NESTED | FIELD | CONSTR | METHOD |
DETAIL: FIELD | CONSTR | METHOD | ||||||||
JAVADOC
org.apache.commons.beanutils.BeanUtilsBean